package net.p0f.samples.rhpam_fuse_integration.rules;

import org.kie.api.KieServices;
import org.kie.api.runtime.KieContainer;
import org.kie.api.runtime.KieSession;

import net.p0f.samples.rhpam_fuse_integration.shared_dom.Award;
import net.p0f.samples.rhpam_fuse_integration.shared_dom.Customer;

public class FactIntegrityMultiple {

	public static void main(String[] args) {
		KieContainer c = KieServices.Factory.get().getKieClasspathContainer();
		KieSession s = c.getKieBase("integrity").newKieSession();

		Customer c1 = new Customer();
		c1.setName("John Doe");
		c1.setAge(27);
		c1.setLoyaltyLevel(Customer.GOLD);
		c1.setLoyaltyAge(10);
		c1.setMilesFlown(15000);

		Award a1 = new Award("Hey, John!");
		a1.setCarrier(c1);

		Customer c2 = new Customer();
		c2.setName("Jane Doe");
		c2.setAge(35);
		c2.setLoyaltyLevel(Customer.PLATINUM);
		c2.setLoyaltyAge(15);
		c2.setMilesFlown(75000);

		Award a2 = new Award("Congratulations, Jane!");
		a2.setCarrier(c2);

		s.insert(c1);
		s.insert(a1);
		s.insert(c2);
		s.insert(a2);

		// This incorrectly prints award/customer combo multiple times for the wrong matching type.
		s.fireAllRules();
		
		s.dispose();
	}

}
