package net.p0f.samples.rhpam_fuse_integration.use_rest;

import java.util.HashMap;
import java.util.Map;

import org.jbpm.bpmn2.handler.ServiceTaskHandler;
import org.kie.api.KieServices;
import org.kie.api.runtime.KieContainer;
import org.kie.api.runtime.KieSession;

import net.p0f.samples.rhpam_fuse_integration.shared_dom.Award;
import net.p0f.samples.rhpam_fuse_integration.shared_dom.Customer;

public class UseRestEasyProxyClient {
	public static void main(String... args) {
		// As usual - create a session from a classpath KieBase.
		KieContainer c = KieServices.Factory.get().getKieClasspathContainer();
		KieSession s = c.getKieBase("serviceTasks").newKieSession();

		// For any kind of service tasks, a WIH needs to be registered.
		s.getWorkItemManager().registerWorkItemHandler("Service Task", new ServiceTaskHandler());

		// The two DOM instances are just placeholders to store results into.
		Customer c1 = new Customer();
		Award a1 = new Award();
		
		// This is the "real" input parameter.
		Integer id = Integer.valueOf(3254426);

		Map<String, Object> p = new HashMap<String, Object>();
		p.put("customer", c1);
		p.put("award", a1);
		p.put("customerId", id);

		// This model's interface refers to the CustomerServiceProxy bean.
		//
		// Not exactly easily configurable, short of creating a custom WorkItemHandler
		// that supports the required parameters.
		s.startProcess("servicetasks.JavaRestProxyServiceTask", p);

		s.fireAllRules();

		s.dispose();
	}
}
